/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Eselon;
import com.portofolio.entity.vo.EselonId;

@Lazy
@Repository
public interface EselonDao extends CrudRepository<Eselon, EselonId> {

    @Cacheable("EselonDaofindOneBy")
    Eselon findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);
    

    @Query(QListAll)
    @Cacheable("EselonDaoFindAllList")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.namaEselon like %:namaEselon% ")
    @Cacheable("EselonDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaEselon") String namaEselon, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.id.kode like :kode")
    @Cacheable("EselonDaoFindByKode")
    Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode, @Param("kdDepartemen") String kdDepartemen);
    
    
    
    String QListAll ="select new map(model.id.kdEselon as kdEselon,model.id.kdProfile as kdProfile "
            + ", model.namaEselon as namaEselon " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.kdDepartemen as kdDepartemen " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", departemen.namaDepartemen as namaDepartemen, model.version as version )" 
            + " from Eselon model left join model.id id left join model.departemen departemen where id.kdProfile=:kdProfile and departemen.id.kdProfile=id.kdProfile and model.kdDepartemen = :kdDepartemen "; 

}
